import 'package:flutter/material.dart';
import 'package:flutter_json_forms/json_form.dart';

void main() {
  runApp(MyApp());
}

class MyApp extends StatelessWidget {
  MyApp({super.key});
  final JsonForm jsonForm = JsonForm(json: json);

  // This widget is the root of your application.
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      title: 'Flutter Demo',
      theme: ThemeData(
        primarySwatch: Colors.blue,
      ),
      debugShowCheckedModeBanner: false,
      home: Scaffold(
        body: SizedBox(
          width: 1080,
          child: jsonForm,
        ),
        floatingActionButton: IconButton(
          icon: const Icon(Icons.data_object),
          onPressed: () {
            print(jsonForm.formData);
          },
        ),
      ),
    );
  }
}

const String json = '''{
  "schema": {
    "type": "object",
    "required": [
      "customer",
      "is_turkey_customer",
      "country_code",
      "run_cycle",
      "platforms",
      "competitors",
      "agreement_start_date",
      "agreement_deadline",
      "has_product_list",
      "trendyol",
      "n11",
      "amazon",
      "hepsiburada",
      "categories",
      "ad_tracker",
      "track_start_date",
      "track_deadline",
      "track_categories",
      "should_deleted"
    ],
    "properties": {
      "Customer": {
        "type": "string"
      },
      "Is Turkey Customer": {
        "type": "boolean",
        "enum": [
          "true",
          "false"
        ]
      },
      "Country Code": {
        "type": "string"
      },
      "Run Cycle": {
        "type": "integer"
      },
      "Platforms": {
        "type": "string",
        "title": "Platforms",
        "enum": [
          "Trendyol",
          "n11",
          "Amazon",
          "Hepsiburada"
        ]
      },
      "Competitors": {
        "type": "string"
      },
      "Agreement Start Date": {
        "type": "string",
        "format": "date"
      },
      "Agreement Deadline": {
        "type": "string",
        "format": "date"
      },
      "Has Product List": {
        "type": "boolean",
        "enum": [
          "true",
          "false"
        ]
      },
      "Categories": {
        "type": "string"
      },
      "Ad Tracker": {
        "type": "boolean",
        "enum": [
          "true",
          "false"
        ]
      },
      "Track Start Date": {
        "type": "string",
        "format": "date"
      },
      "Track Deadline": {
        "type": "string",
        "format": "date"
      },
      "Track Categories": {
        "type": "string"
      },
      "Should Deleted": {
        "type": "boolean",
        "enum": [
          "true",
          "false"
        ]
      }
    }
  },
  "ui_schema": {
    "type": "VerticalLayout",
    "elements": [
      {
        "type": "HorizontalLayout",
        "elements": [
          {
            "type": "Control",
            "scope": "#/properties/Customer"
          }
        ]
      },
      {
        "type": "HorizontalLayout",
        "elements": [
          {
            "type": "Control",
            "scope": "#/properties/Is Turkey Customer"
          }
        ]
      },
      {
        "type": "HorizontalLayout",
        "elements": [
          {
            "type": "Control",
            "scope": "#/properties/Country Code"
          }
        ]
      },
      {
        "type": "HorizontalLayout",
        "elements": [
          {
            "type": "Control",
            "scope": "#/properties/Run Cycle"
          }
        ]
      },
      {
        "type": "HorizontalLayout",
        "elements": [
          {
            "type": "Control",
            "scope": "#/properties/Platforms",
            "options": {
              "multiple": true
            }
          }
        ]
      },
      {
        "type": "HorizontalLayout",
        "elements": [
          {
            "type": "Control",
            "scope": "#/properties/Trendyol"
          }
        ]
      },
      {
        "type": "HorizontalLayout",
        "elements": [
          {
            "type": "Control",
            "scope": "#/properties/n11"
          }
        ]
      },
      {
        "type": "HorizontalLayout",
        "elements": [
          {
            "type": "Control",
            "scope": "#/properties/Amazon"
          }
        ]
      },
      {
        "type": "HorizontalLayout",
        "elements": [
          {
            "type": "Control",
            "scope": "#/properties/Hepsiburada"
          }
        ]
      },
      {
        "type": "HorizontalLayout",
        "elements": [
          {
            "type": "Control",
            "scope": "#/properties/Competitors"
          }
        ]
      },
      {
        "type": "HorizontalLayout",
        "elements": [
          {
            "type": "Control",
            "scope": "#/properties/Agreement Start Date"
          }
        ]
      },
      {
        "type": "HorizontalLayout",
        "elements": [
          {
            "type": "Control",
            "scope": "#/properties/Agreement Deadline"
          }
        ]
      },
      {
        "type": "HorizontalLayout",
        "elements": [
          {
            "type": "Control",
            "scope": "#/properties/Categories"
          }
        ]
      },
      {
        "type": "HorizontalLayout",
        "elements": [
          {
            "type": "Control",
            "scope": "#/properties/Ad Tracker"
          }
        ]
      },
      {
        "type": "HorizontalLayout",
        "elements": [
          {
            "type": "Control",
            "scope": "#/properties/Track Start Date"
          }
        ]
      },
      {
        "type": "HorizontalLayout",
        "elements": [
          {
            "type": "Control",
            "scope": "#/properties/Track Deadline"
          }
        ]
      },
      {
        "type": "HorizontalLayout",
        "elements": [
          {
            "type": "Control",
            "scope": "#/properties/Track Categories"
          }
        ]
      },
      {
        "type": "HorizontalLayout",
        "elements": [
          {
            "type": "Control",
            "scope": "#/properties/Has Product List"
          }
        ]
      },
      {
        "type": "HorizontalLayout",
        "elements": [
          {
            "type": "Control",
            "scope": "#/properties/Should Deleted"
          }
        ]
      }
    ]
  },
  "form_data": {
    "Platforms": []
  }
}''';
